<template>
  <div class="mb-4">
    <template v-if="!restaurant.closed && restaurant.waitingCount > 0">
      <div v-if="isLogin" class="account-info-container">
        <hello-member />
      </div>

      <template>
        <div class="general-today">
          <today />
        </div>
        <div class="circle">
          <div
            class="waiting-badge flex flex-column align-items-center justify-content-center"
          >
            <div class="display-number">{{ waitingInfo.waitingCount }}</div>
            <div class="text-center content-small content-bold">
              {{ $t("restaurant.waitingCount") }}
            </div>
          </div>
          <div
            v-if="!restaurant.longWaiting"
            class="waiting-time content-small"
          >
            {{
              $t("restaurant.waitingTime", {
                minutes: waitingInfo.estimatedWaitingMinutes
              })
            }}
          </div>
        </div>
        <div class="text-center">
          <div
            class="content-large mb-2"
            v-if="!isLogin || restaurant.waitingDisabled"
          >
            {{ $t("restaurant.goToPickNumber") }}
          </div>
          <div class="caption">{{ $t("restaurant.waitingDisclaimer") }}</div>
        </div>
      </template>

      <template v-if="isLogin && !restaurant.waitingDisabled">
        <router-link class="waiting-button" :to="{ name: 'WaitingForm' }">{{
          $t("restaurant.iWantToWait")
        }}</router-link>
      </template>

      <template v-if="!isLogin && !restaurant.waitingDisabled">
        <button
          class="login-request"
          @click.prevent.stop="
            startLogin(['callRouterMethod', 'push', bookingPageLink])
          "
        >
          <login-banner type="waiting" />
        </button>
      </template>
    </template>
    <template v-else>
      <div class="info-wrapper">
        <today />
        <div
          class="info-board flex flex-column align-items-center justify-content-center text-center"
        >
          <div>
            <template v-if="restaurant.inOperation">
              <template v-if="restaurant.openWaiting">
                <div class="info-title title-lg c-blue">
                  {{ $t("restaurant.noWaiting") }}
                </div>
                <div class="info-desc">
                  {{ $t("restaurant.noWaitingDesc") }}
                </div>
              </template>
              <template v-else>
                <div class="info-title title-lg c-pigeon-grey">
                  {{ $t("restaurant.waitingStatusClosed") }}
                </div>
              </template>
            </template>
            <template v-else>
              <div
                v-if="!restaurant.isAfterFirstOpenTime"
                class="info-title title-lg c-pigeon-grey"
              >
                {{ $t("restaurant.notOpen") }}
              </div>
              <div
                v-if="restaurant.inClosingTime"
                class="info-title title-lg c-pigeon-grey"
              >
                {{ $t("restaurant.closed") }}
              </div>
              <div v-if="restaurant.inRestTime" class="title-lg c-pigeon-grey">
                {{ $t("restaurant.waitingTemporarilyClosedLine1") }}
              </div>
              <div
                v-if="restaurant.inRestTime"
                class="info-title title c-pigeon-grey"
              >
                {{ $t("restaurant.waitingTemporarilyClosedLine2") }}
              </div>
              <div class="info-desc content-large">
                {{
                  restaurant.nextOpeningTime
                    ? $t("restaurant.closedDesc", {
                        nextOpenTimeFrom: restaurant.nextOpeningTime.from
                      })
                    : $t("restaurant.noNextOpenTime")
                }}
              </div>
            </template>
          </div>
        </div>
        <div class="text-center mt-3" v-show="restaurant.inOperation">
          <div class="caption">{{ $t("restaurant.waitingDisclaimer") }}</div>
        </div>
      </div>
      <template v-if="!isLogin">
        <a class="login-request" href="/login" @click.prevent.stop="startLogin"
          ><login-banner type="waiting"
        /></a>
      </template>
    </template>

    <template v-if="alternativeRestaurants.length">
      <p class="text-center c-secondary-black">
        {{ $t("restaurant.iDontWantToWait") }}
      </p>
      <horizontal-scroll-box>
        <div
          class="alternative-item"
          v-for="(r, key) in alternativeRestaurants"
          :key="key"
        >
          <restaurant
            list-type="available recommendation"
            class="alternative-restaurant"
            strategy="waiting"
            :key="r.id"
            :restaurant="r"
          />
        </div>
      </horizontal-scroll-box>
    </template>
  </div>
</template>
<script>
import { mapState, mapGetters, mapActions } from "vuex";
import { isNowBetween, isNowBefore } from "@/utils";
import Restaurant from "@/components/Group/RestaurantItem";
import RestaurantModel from "@/models/restaurant";
import { GoldenLabel, LaurelCrownBlock } from "@/components/LaurelCrownBlock";
import LoginBanner from "@/components/LoginBanner";
import HelloMember from "@/components/HelloMember";
import HorizontalScrollBox from "@/components/HorizontalScrollBox";
import Today from "@/components/Restaurant/Today";

export default {
  components: {
    Restaurant,
    GoldenLabel,
    LaurelCrownBlock,
    LoginBanner,
    HelloMember,
    HorizontalScrollBox,
    Today
  },
  computed: {
    ...mapState("restaurant", ["restaurant"]),
    ...mapState("account", ["account"]),
    ...mapGetters("account", ["isLogin", "isGeneralMember", "isVipMember"]),
    ...mapGetters("theme", ["themeClasses"]),
    waitingInfo() {
      return this.restaurant.waitingInfo;
    },
    alternativeRestaurants() {
      const params = this.$route.params;
      return this.restaurant.alternateWaitingBranches.map(
        r => new RestaurantModel(params.date, r)
      );
    }
  },
  methods: {
    ...mapActions("account", ["startLogin"])
  },
  mounted() {
    var content = "";
    if (!this.restaurant.closed && this.restaurant.waitingCount > 0) {
      content = this.$t("restaurant.waitingCount");
    } else {
      if (this.restaurant.inOperation) {
        if (this.restaurant.openWaiting) {
          content = this.$t("restaurant.noWaitingDesc");
        } else {
          content = this.$t("restaurant.waitingStatusClosed");
        }
      } else {
        if (this.restaurant.nextOpeningTime) {
          content = this.$t("restaurant.closedDesc", {
            nextOpenTimeFrom: this.restaurant.nextOpeningTime.from
          });
        } else {
          content = this.$t("restaurant.noNextOpenTime");
        }
      }
    }

    window.gtag("event", `pageview`, {
      event_category: "美食地圖餐廳候位",
      event_label: JSON.stringify({
        category: [
          this.restaurant.groupName,
          this.restaurant.buildingName,
          this.restaurant.floor
        ].join(" - "),
        value: this.restaurant.company.name,
        content
      })
    });
  }
};
</script>
<style lang="scss" scoped>
.circle {
  position: relative;
  width: 146px;
  height: 146px;
  border-radius: 50%;
  margin: 15px auto 40px auto;
  border: 2px solid $color-pigeon-grey;
}
.waiting-badge {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  bottom: 5%;
  color: $color-secondary-black;
}
.waiting-time {
  position: absolute;
  bottom: 0;
  left: 50%;
  width: auto;
  transform: translate(-50%, 45%);
  background-color: $color-skm-red;
  color: $color-white;
  border-radius: 15px;
  line-height: 30px;
  padding: 0 0.75em;
  white-space: nowrap;
}

.alternative-item {
  padding-left: $grid-gutter-width/2;
  scroll-snap-align: start;
  margin-bottom: 30px;
  &:last-child {
    padding-right: $grid-gutter-width/2;
  }
}

.alternative-restaurant {
  background-color: $color-white;
}

.restaurant-item.restaurant-item {
  padding: 0;
  width: 290px;
  border: 1px solid $color-sky-grey;
  border-radius: 2px;
  overflow: hidden;
}

.waiting-button {
  display: block;
  width: 255px;
  line-height: 48px;
  background-color: $color-skm-red;
  color: $color-white;
  text-align: center;
  margin: 30px auto 70px;

  @include media-breakpoint-up(md) {
    width: 315px;
  }
}

.vip-laurel {
  display: block;
  text-align: center;
  color: $color-gold-300;
  margin: 40px 0 40px;

  @include media-breakpoint-up(md) {
    margin: 80px 0 40px;
  }
}

.login-request {
  display: block;
  width: 100%;
  text-align: center;
  margin: 20px 0;
  cursor: pointer;
  background: transparent;
  border: none;
  padding: 0;

  @include media-breakpoint-up(md) {
    margin: 40px 0;
  }
}

.account-info-container {
  margin-top: 24px;
}

.general-today {
  margin-top: 30px;
}
</style>
